Index: /branches/network/src/lib/coord/p_node.cc
===================================================================
--- /branches/network/src/lib/coord/p_node.cc	(revision 7443)
+++ /branches/network/src/lib/coord/p_node.cc	(revision 7444)
@@ -59,4 +59,7 @@
   if (parent != NULL)
     parent->addChild(this);
+  
+  this->relCoordinate_handle = this->registerVarId( new SynchronizeableVector( &relCoordinate, &relCoordinate_write, "coordinate" ) );
+  this->relDirection_handle = this->registerVarId( new SynchronizeableQuaternion( &relDirection, &relDirection_write, "direction" ) );
 }
 
@@ -1083,256 +1086,11 @@
 
 /**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PNode::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( BaseObject::writeState, NWT_PN_BO_WRITESTATE );
-
-  //   char * parentName = NULL;
-  //   SYNCHELP_READ_STRINGM( parentName );
-  //
-  //   if ( strcmp(parentName, "")==0 )
-  //   {
-  //     setParent( (char*)NULL );
-  //   }
-  //   else
-  //   {
-  //     setParent( parentName );
-  //   }
-  //
-  //  delete[] parentName;
-
-  int parentMode;
-  SYNCHELP_READ_INT( parentMode, NWT_PN_PARENTMODE );
-  this->setParentMode((PARENT_MODE)parentMode);
-
-  float f1, f2, f3, f4;
-
-  SYNCHELP_READ_FLOAT( f1, NWT_PN_COORX );
-  SYNCHELP_READ_FLOAT( f2, NWT_PN_COORY );
-  SYNCHELP_READ_FLOAT( f3, NWT_PN_COORZ );
-  this->setRelCoor( f1, f2, f3 );
-
-
-  SYNCHELP_READ_FLOAT( f1, NWT_PN_ROTV );
-  SYNCHELP_READ_FLOAT( f2, NWT_PN_ROTX );
-  SYNCHELP_READ_FLOAT( f3, NWT_PN_ROTY );
-  SYNCHELP_READ_FLOAT( f4, NWT_PN_ROTZ );
-  this->setRelDir( Quaternion( Vector(f2, f3, f4), f1 ) );
-
-  //   int n;
-  //   char * childName;
-  //
-  //   PRINTF(0)("JKLO %d %d %d %d\n", data[__synchelp_read_i], data[__synchelp_read_i+1], data[__synchelp_read_i+2], data[__synchelp_read_i+3]);
-  //   SYNCHELP_READ_INT( n );
-  //   PRINTF(0)("read %s:n=%d\n", this->getName(), n);
-  //
-  //   for (int i = 0; i<n; i++)
-  //   {
-  //     SYNCHELP_READ_STRINGM( childName );
-  //     PRINTF(0)("RCVD CHILD = %s\n", childName);
-  //     addChild( childName );
-  //     delete childName;
-  //     childName = NULL;
-  //   }
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PNode::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  SYNCHELP_WRITE_FKT( BaseObject::readState, NWT_PN_BO_WRITESTATE );
-
-  //   if ( this->parent )
-  //   {
-  //     SYNCHELP_WRITE_STRING( parent->getName() );
-  //   }
-  //   else
-  //   {
-  //     SYNCHELP_WRITE_STRING( "" );
-  //   }
-
-  SYNCHELP_WRITE_INT( this->parentMode, NWT_PN_PARENTMODE );
-
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.x, NWT_PN_COORX );
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.y, NWT_PN_COORY );
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.z, NWT_PN_COORZ );
-
-  SYNCHELP_WRITE_FLOAT( this->relDirection.w, NWT_PN_ROTV );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.x, NWT_PN_ROTX );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.y, NWT_PN_ROTY );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.z, NWT_PN_ROTZ );
-
-  //   int n = children.size();
-  //   //check if camera is in children
-  //   for (std::list<PNode*>::const_iterator it = children.begin(); it!=children.end(); it++)
-  //   {
-  //     if ( (*it)->isA(CL_CAMERA) )
-  //       n--;
-  //   }
-  //   PRINTF(0)("write %s:n=%d\n", this->getName(), n);
-  //   SYNCHELP_WRITE_INT( n );
-  //   PRINTF(0)("ASDF %d %d %d %d\n", data[__synchelp_write_i-4], data[__synchelp_write_i-3], data[__synchelp_write_i-2], data[__synchelp_write_i-1]);
-  //
-  //
-  //   for (std::list<PNode*>::const_iterator it = children.begin(); it!=children.end(); it++)
-  //   {
-  //     //dont add camera because there is only one camera attached to local player
-  //     if ( !(*it)->isA(CL_CAMERA) )
-  //     {
-  //       PRINTF(0)("SENDING CHILD: %s\n", (*it)->getName());
-  //       SYNCHELP_WRITE_STRING( (*it)->getName() );
-  //     }
-  //   }
-
-  return SYNCHELP_WRITE_N;
-}
-
-#define __FLAG_COOR 1
-#define __FLAG_ROT  2
-
-#define __OFFSET_POS 1
-#define __OFFSET_ROT 0.05
-
-/**
- * Writes data from network containing information about the state which has changed
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PNode::writeSync( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  if ( this->getHostID()==this->getOwner() )
-  {
-    return SYNCHELP_READ_N;
-  }
-
-  byte flags = 0;
-  SYNCHELP_READ_BYTE( flags, NWT_PN_FLAGS );
-  //PRINTF(0)("%s::FLAGS = %d\n", this->getName(), flags);
-
-  float f1, f2, f3, f4;
-
-  if ( flags & __FLAG_COOR )
-  {
-    SYNCHELP_READ_FLOAT( f1, NWT_PN_SCOORX );
-    SYNCHELP_READ_FLOAT( f2, NWT_PN_SCOORY );
-    SYNCHELP_READ_FLOAT( f3, NWT_PN_SCOORZ );
-    PRINTF(0)("RCVD COOR: %f %f %f\n", f1, f2, f3);
-    this->setRelCoor( f1, f2, f3 );
-  }
-
-  if ( flags & __FLAG_ROT )
-  {
-    SYNCHELP_READ_FLOAT( f1, NWT_PN_SROTV );
-    SYNCHELP_READ_FLOAT( f2, NWT_PN_SROTX );
-    SYNCHELP_READ_FLOAT( f3, NWT_PN_SROTY );
-    SYNCHELP_READ_FLOAT( f4, NWT_PN_SROTZ );
-    PRINTF(0)("RCVD QUAT: %f %f %f %f\n", f1, f2, f3, f4);
-    //this->setRelDir( Quaternion( Vector(f2, f3, f4), f1 ) );
-    Quaternion q;
-    q.w = f1;
-    q.v.x = f2;
-    q.v.y = f3;
-    q.v.z = f4;
-    this->setAbsDir( q );
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PNode::readSync( byte * data, int maxLength )
-{
-  //WARNING: if you change this file make sure you also change needsReadSync
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( this->getHostID()!=0 && this->getHostID()!=this->getOwner() )
-  {
-    return SYNCHELP_WRITE_N;
-  }
-
-  byte flags = 0;
-  if ( fabs( coorx - relCoordinate.x ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coory - relCoordinate.y ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coorz - relCoordinate.z ) > __OFFSET_POS*0.05*this->velocity.len() )
-    flags |= __FLAG_COOR;
-
-  if ( fabs( rotw - absDirection.w ) > __OFFSET_ROT ||
-       fabs( rotx - absDirection.v.x ) > __OFFSET_ROT ||
-       fabs( roty - absDirection.v.y ) > __OFFSET_ROT ||
-       fabs( rotz - absDirection.v.z ) > __OFFSET_ROT )
-    flags |= __FLAG_ROT;
-
-
-  SYNCHELP_WRITE_BYTE( flags, NWT_PN_FLAGS );
-  PRINTF(0)("FLAGS = %d\n", flags);
-
-  if ( flags & __FLAG_COOR )
-  {
-
-    PRINTF(0)("SEND COOR: %f %f %f\n", this->relCoordinate.x, this->relCoordinate.y, this->relCoordinate.z);
-
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.x, NWT_PN_SCOORX );
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.y, NWT_PN_SCOORY );
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.z, NWT_PN_SCOORZ );
-
-    coorx = relCoordinate.x;
-    coory = relCoordinate.y;
-    coorz = relCoordinate.z;
-  }
-
-  if ( flags & __FLAG_ROT )
-  {
-
-    PRINTF(0)("SEND QUAT: %f %f %f %f\n", this->absDirection.w, this->absDirection.v.x, this->absDirection.v.y, this->absDirection.v.z);
-
-    SYNCHELP_WRITE_FLOAT( this->absDirection.w, NWT_PN_SROTV );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.x, NWT_PN_SROTX );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.y, NWT_PN_SROTY );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.z, NWT_PN_SROTZ );
-
-    rotw = absDirection.w;
-    rotx = absDirection.v.x;
-    roty = absDirection.v.y;
-    rotz = absDirection.v.z;
-  }
-
-  return SYNCHELP_WRITE_N;
-}
-
-bool PNode::needsReadSync( )
-{
-  if ( fabs( coorx - relCoordinate.x ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coory - relCoordinate.y ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coorz - relCoordinate.z ) > __OFFSET_POS*0.05*this->velocity.len() )
-    return true;
-
-  if ( fabs( rotw - absDirection.w ) > __OFFSET_ROT ||
-       fabs( rotx - absDirection.v.x ) > __OFFSET_ROT ||
-       fabs( roty - absDirection.v.y ) > __OFFSET_ROT ||
-       fabs( rotz - absDirection.v.z ) > __OFFSET_ROT )
-    return true;
-
-  return false;
-}
+ * handles changes in synchronizable variables
+ * @param id id's which changed
+ */
+void PNode::varChangeHandler( std::list< int > & id )
+{
+#warning implement this
+}
+
+
Index: /branches/network/src/lib/coord/p_node.h
===================================================================
--- /branches/network/src/lib/coord/p_node.h	(revision 7443)
+++ /branches/network/src/lib/coord/p_node.h	(revision 7444)
@@ -187,10 +187,4 @@
   float distance(const PNode* node) const { return (this->getAbsCoor() - node->getAbsCoor()).len(); };
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-  int       writeSync(const byte* data, int length, int sender);
-  int       readSync(byte* data, int maxLength );
-  bool      needsReadSync();
-
  private:
   /** tells the child that the parent's Coordinate has changed */
@@ -244,4 +238,13 @@
     float roty;
     float rotz;
+    
+  private:
+    int relCoordinate_handle;
+    int relDirection_handle;
+    Vector relCoordinate_write;
+    Quaternion relDirection_write;
+    
+  public:
+    virtual void varChangeHandler( std::list<int> & id );
 };
 
Index: /branches/network/src/lib/lang/base_object.cc
===================================================================
--- /branches/network/src/lib/lang/base_object.cc	(revision 7443)
+++ /branches/network/src/lib/lang/base_object.cc	(revision 7444)
@@ -177,33 +177,2 @@
 
 }
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int BaseObject::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_STRING( this->objectName, NWT_BO_NAME );
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int BaseObject::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  //PRINTF(0)("objectname = %s\n", this->objectName);
-  SYNCHELP_WRITE_STRING( this->objectName, NWT_BO_NAME );
-
-  return SYNCHELP_WRITE_N;
-}
Index: /branches/network/src/lib/lang/base_object.h
===================================================================
--- /branches/network/src/lib/lang/base_object.h	(revision 7443)
+++ /branches/network/src/lib/lang/base_object.h	(revision 7444)
@@ -51,14 +51,11 @@
   bool operator==(ClassID classID) { return this->isA(classID); };
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-
  protected:
    void setClassID(ClassID classID, const std::string& className);
+   std::string        objectName;        //!< The name of this object
 
  private:
     std::string        className;        //!< the name of the class
     long               classID;          //!< this is the id from the class_id.h enumeration
-    std::string        objectName;       //!< The name of this object
 
     ClassList*         classList;        //!< Pointer to the ClassList this Object is inside of
Index: /branches/network/src/lib/network/Makefile.am
===================================================================
--- /branches/network/src/lib/network/Makefile.am	(revision 7443)
+++ /branches/network/src/lib/network/Makefile.am	(revision 7444)
@@ -15,5 +15,14 @@
 		      handshake.cc \
 		      network_game_manager.cc \
-		      converter.cc
+		      converter.cc \
+		      \
+		      synchronizeable_var/synchronizeable_var.cc \
+		      synchronizeable_var/synchronizeable_vector.cc \
+		      synchronizeable_var/synchronizeable_int.cc \
+		      synchronizeable_var/synchronizeable_quaternion.cc \
+		      synchronizeable_var/synchronizeable_string.cc \
+		      synchronizeable_var/synchronizeable_float.cc \
+		      synchronizeable_var/synchronizeable_bool.cc \
+		      synchronizeable_var/synchronizeable_uint.cc 
 
 
@@ -32,5 +41,14 @@
 		 network_game_manager.h \
 		 converter.h \
-		 netdefs.h
+		 netdefs.h \
+		 \
+		 synchronizeable_var/synchronizeable_var.h \
+		 synchronizeable_var/synchronizeable_vector.h \
+		 synchronizeable_var/synchronizeable_int.h \
+		 synchronizeable_var/synchronizeable_quaternion.h \
+		 synchronizeable_var/synchronizeable_string.h \
+		 synchronizeable_var/synchronizeable_float.h \
+		 synchronizeable_var/synchronizeable_bool.h \
+		 synchronizeable_var/synchronizeable_uint.h
 
 
Index: /branches/network/src/lib/network/handshake.cc
===================================================================
--- /branches/network/src/lib/network/handshake.cc	(revision 7443)
+++ /branches/network/src/lib/network/handshake.cc	(revision 7444)
@@ -31,9 +31,15 @@
 
   this->setIsServer(server);
-  this->clientId = clientId;
-  this->networkGameManagerId = networkGameManagerId;
-  this->state = 0;
-  this->isOk = false;
-  this->setOwner(0);
+  this->localState.hostId = clientId;
+  this->localState.networkManagerId = networkGameManagerId;
+ 
+  orxId_handler = registerVarId( new SynchronizeableInt( &localState.orxId, &remoteState.orxId, "orxonoxId" ) );
+  version_handler = registerVarId( new SynchronizeableInt( &localState.version, &remoteState.version, "version" ) );
+  netManId_handler = registerVarId( new SynchronizeableInt( &localState.networkManagerId, &remoteState.networkManagerId, "networkManagerId" ) );
+  hostId_handler = registerVarId( new SynchronizeableInt( &localState.hostId, &remoteState.hostId, "hostId" ) );
+  completed_handler = registerVarId( new SynchronizeableInt( &localState.completed, &remoteState.completed, "completed" ) );
+  error_handler = registerVarId( new SynchronizeableInt( &localState.error, &remoteState.error, "error" ) );
+  errorString_handler = registerVarId( new SynchronizeableString( &localState.errorString, &remoteState.errorString, "errorString" ) );
+
 
   this->setSynchronized(true);
@@ -41,165 +47,10 @@
 }
 
-int Handshake::writeBytes( const byte * data, int length, int sender)
-{
-  PRINTF(5)("Handshake::writeBytes states = %d %d %d %d (%d)\n", hasState( HS_RECVD_INIT ), hasState( HS_RECVD_VER ), hasState( HS_RECVD_HID ), hasState( HS_COMPLETED ), state);
-
-  SYNCHELP_READ_BEGIN();
-
-  if ( hasState( HS_COMPLETED ) )
-       return 0;
-
-  if ( !hasState( HS_RECVD_INIT ) )
-  {
-    if ( length != _INITIAL_DATA_LENGTH )
-    {
-      PRINTF(0)("initial packet has wrong size %d instead of %d\n", length, _INITIAL_DATA_LENGTH);
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    if ( strncmp((char*)data, _INITIAL_DATA, length) )
-    {
-      PRINTF(0)("initial packed does not match\n");
-      setState( HS_COMPLETED );
-      return length;
-    }
-
-    setState( HS_RECVD_INIT );
-    PRINTF(0)("got valid initial packet from client %d\n", clientId);
-    return length;
-  }
-
-  if ( hasState( HS_RECVD_INIT ) && !hasState( HS_RECVD_VER ) )
-  {
-    if ( length != _ORXONOX_VERSION_LENGTH )
-    {
-      PRINTF(0)("version number packet has wrong size %d instead of %d\n", length, _ORXONOX_VERSION_LENGTH);
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    if ( strncmp((char*)data, _ORXONOX_VERSION, length) )
-    {
-      PRINTF(0)("versions do not match\n");
-      setState( HS_COMPLETED );
-      return length;
-    }
-
-    setState( HS_RECVD_VER );
-
-    PRINTF(0)("client %d's version does match\n", clientId);
-    return length;
-  }
-
-  if ( !isServer() && hasState( HS_RECVD_VER ) && !hasState( HS_RECVD_HID ) )
-  {
-    /*if ( length != INTSIZE+INTSIZE )
-    {
-      PRINTF(0)("hostID packet has wrong size %d instead of %d\n", length, INTSIZE+INTSIZE);
-      setState( HS_COMPLETED );
-      return 0;
-  }*/
-
-    setState( HS_COMPLETED );
-    setState( HS_RECVD_HID );
-    this->isOk = true;
-    SYNCHELP_READ_INT( this->newHostId, NWT_HS_HOST_ID );
-    SYNCHELP_READ_INT( this->newNetworkGameManagerId, NWT_HS_NGM_ID );
-
-    if ( newHostId == 0 )
-    {
-      setState( HS_WAS_REJECT );
-      isOk = false;
-      PRINTF(0)("Server did not accept handshake!\n");
-    }
-    else
-    {
-      PRINTF(0)("got my hostID: %d and networkGameManagerId: %d\n", newHostId, newNetworkGameManagerId);
-    }
-    return SYNCHELP_READ_N;
-  }
-
-}
-
-int Handshake::readBytes( byte * data, int maxLength, int * reciever )
-{
-  PRINTF(5)("Handshake::readBytes states = %d %d %d %d (%d)\n", hasState( HS_SENT_INIT ), hasState( HS_SENT_VER ), hasState( HS_SENT_HID ), hasState( HS_COMPLETED ), state);
-
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( hasState( HS_COMPLETED ) )
-    return 0;
-
-  if ( !hasState( HS_SENT_INIT ) )
-  {
-    if ( maxLength < _INITIAL_DATA_LENGTH )
-    {
-      PRINTF(0)("buffer too small for _INITIAL_DATA");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_INIT );
-    memcpy(data, _INITIAL_DATA, _INITIAL_DATA_LENGTH);
-    if ( this->isServer() )
-      *reciever = clientId;
-    return _INITIAL_DATA_LENGTH;
-  }
-
-  if ( hasState( HS_RECVD_INIT ) && hasState( HS_SENT_INIT ) && !hasState( HS_SENT_VER ) )
-  {
-    if ( maxLength < _ORXONOX_VERSION_LENGTH )
-    {
-      PRINTF(0)("buffer too small for version number");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_VER );
-    memcpy(data, _ORXONOX_VERSION, _ORXONOX_VERSION_LENGTH);
-    if ( this->isServer() )
-      *reciever = clientId;
-    return _ORXONOX_VERSION_LENGTH;
-  }
-
-  if ( isServer() && hasState( HS_RECVD_VER) && hasState( HS_SENT_VER ) && !hasState( HS_SENT_HID ) )
-  {
-    if ( maxLength < 2 )
-    {
-      PRINTF(0)("buffer too small for ID");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_HID );
-    setState( HS_COMPLETED );
-
-    if ( hasState( HS_DO_REJECT ) )
-    {
-      isOk = false;
-      //memcpy(data, (byte*)0, 4);
-      SYNCHELP_WRITE_INT( 0, NWT_HS_HOST_ID);
-      SYNCHELP_WRITE_INT( 0, NWT_HS_NGM_ID);
-    }
-    else
-    {
-      isOk = true;
-      //memcpy(data, &clientId, 4);
-      SYNCHELP_WRITE_INT( clientId, NWT_HS_HOST_ID );
-      SYNCHELP_WRITE_INT( networkGameManagerId, NWT_HS_NGM_ID );
-    }
-    *reciever = clientId;
-    return SYNCHELP_WRITE_N;
-  }
-
-  return 0;
-}
-
-void Handshake::writeDebug( ) const
+/**
+ * handler for changes in synced vars
+ * @param id id's which have changed
+ */
+void Handshake::varChangeHandler( std::list< int > & id )
 {
 }
 
-void Handshake::readDebug( ) const
-{
-}
Index: /branches/network/src/lib/network/handshake.h
===================================================================
--- /branches/network/src/lib/network/handshake.h	(revision 7443)
+++ /branches/network/src/lib/network/handshake.h	(revision 7444)
@@ -10,23 +10,20 @@
 #include "synchronizeable.h"
 
-#define _INITIAL_DATA "orxonox"
-#define _INITIAL_DATA_LENGTH 7
+#define _INITIAL_DATA 0xF91337A0
 
-#define _ORXONOX_VERSION "\x00\x00\x00\x01"
-#define _ORXONOX_VERSION_LENGTH 4
+#define _ORXONOX_VERSION 1
 
-typedef enum HandshakeState {
-  HS_SENT_INIT  = 0x00000001,
-  HS_RECVD_INIT = 0x00000002,
-  HS_SENT_VER   = 0x00000004,
-  HS_RECVD_VER  = 0x00000008,
-  HS_SENT_HID   = 0x00000010,
-  HS_RECVD_HID  = 0x00000020,
-  HS_COMPLETED  = 0x00000040,
-
-  HS_DO_REJECT  = 0x00010000,
-  HS_WAS_REJECT = 0x00020000,
-
-  NUM_STATES
+struct HandshakeState {
+  int orxId;
+  int version;
+  
+  int networkManagerId;
+  int hostId;
+  
+  int completed;
+  
+  int error;
+  
+  std::string errorString;
 };
 
@@ -34,28 +31,24 @@
 {
   public:
-    Handshake(bool server, int clientId = 0, int networkGameManagerId = 0);
-    inline bool       completed(){ return hasState( HS_COMPLETED ); }
-    inline bool       ok(){ return isOk; }
-    inline int        getHostId(){ return newHostId; }
-    inline int        getNetworkGameManagerId(){ return newNetworkGameManagerId; }
-
-    inline void       doReject(){ setState(HS_DO_REJECT); }
-
-    virtual int       writeBytes(const byte* data, int length, int sender);
-    virtual int       readBytes(byte* data, int maxLength, int * reciever);
-    virtual void      writeDebug() const;
-    virtual void      readDebug() const;
+    Handshake( bool server, int clientId = 0, int networkGameManagerId = 0 );
+    inline bool       completed(){ return localState.completed != 0 && remoteState.completed != 0; }
+    inline bool       ok(){ return localState.error == 0 && remoteState.error == 0; }
+    inline int        getHostId(){ return localState.hostId; }
+    inline int        getNetworkGameManagerId(){ return localState.networkManagerId; }
+    inline void       doReject( std::string reason ){ remoteState.error = 1; remoteState.errorString = "the server rejected your connection ["+ reason +"]"; }
+    
+    virtual void varChangeHandler( std::list<int> & id );
 
   private:
-    int               state;
-    int               clientId;
-    int               networkGameManagerId;
-    int               newHostId;
-    int               newNetworkGameManagerId;
-    bool              isOk;
-
-    inline bool       hasState( int a ){ return (state & a) == a; }
-    inline void       setState( int a ){ state = state | a; }
-    inline void       unsetState( int a ){ state = state & (~a); }
+    HandshakeState localState;
+    HandshakeState remoteState;
+    
+    int netManId_handler;
+    int hostId_handler;
+    int completed_handler;
+    int error_handler;
+    int errorString_handler;
+    int orxId_handler;
+    int version_handler;
 
 };
Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 7443)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 7444)
@@ -141,10 +141,4 @@
     {
       sendEntityList( sender );
-      continue;
-    }
-    else if ( b == NET_REQUEST_SYNC )
-    {
-      if ( !handleRequestSync( i, data, length, sender ) )
-        return i;
       continue;
     }
@@ -532,6 +526,5 @@
     s->setSynchronized(true);
     //this->networkStream->connectSynchronizeable( *s );
-    if ( !isServer() )
-      s->setIsOutOfSync( true );
+
     PRINTF(0)("Fabricated %s with id %d\n", s->getClassName(), s->getUniqueID());
 
@@ -601,25 +594,4 @@
 }
 
-/**
- * Tell the synchronizeable that a user's synchronizeable is out of sync
- * @param uniqueID: unique ID assigned with the entity which is out of sync
- * @param userID: user ID who's synchronizeable is out of sync
- */
-void NetworkGameManager::doRequestSync( int uniqueID, int userID )
-{
-  SynchronizeableList::const_iterator it,e;
-  it = this->networkStream->getSyncBegin();
-  e = this->networkStream->getSyncEnd();
-
-  while ( it != e )
-  {
-    if ( (*it)->getUniqueID() == uniqueID )
-    {
-      (*it)->requestSync( userID );
-      break;
-    }
-    it++;
-  }
-}
 
 /**
@@ -697,6 +669,4 @@
   assert(player != NULL);
 
-  s->setIsOutOfSync( true );
-
   PRINTF(0)("uniqueID = %d\n", s->getUniqueID());
 
@@ -902,21 +872,4 @@
   return true;
 }
-
-bool NetworkGameManager::handleRequestSync( int & i, const byte * data, int length, int sender )
-{
-  if ( INTSIZE > length-i )
-  {
-    PRINTF(1)("Cannot read uniqueID from buffer! Not enough data left!\n");
-    return false;
-  }
-  int uniqueID;
-  i += Converter::byteArrayToInt( &data[i], &uniqueID );
-
-  PRINTF(0)("handleRequestSync %d %d\n", uniqueID, sender);
-  doRequestSync( uniqueID, sender );
-
-  return true;
-}
-
 
 /**
@@ -986,25 +939,3 @@
 }
 
-void NetworkGameManager::sync( int uniqueID, int owner )
-{
-  /*if ( owner==this->getHostID() )
-  return;*/
-
-  if ( !isServer() )
-    executeRequestSync( uniqueID, 0 );
-  else
-    executeRequestSync( uniqueID, owner );
-}
-
-void NetworkGameManager::executeRequestSync( int uniqueID, int user )
-{
-  PRINTF(0)("executeRequestSync %d %d\n", uniqueID, user);
-  if ( user >= outBuffer.size() )
-    resizeBufferVector( user );
-
-  if ( !writeToClientBuffer( outBuffer[user], (byte)NET_REQUEST_SYNC ) )
-    return;
-  if ( !writeToClientBuffer( outBuffer[user], uniqueID ) )
-    return;
-}
-
+
Index: /branches/network/src/lib/network/network_game_manager.h
===================================================================
--- /branches/network/src/lib/network/network_game_manager.h	(revision 7443)
+++ /branches/network/src/lib/network/network_game_manager.h	(revision 7444)
@@ -35,8 +35,4 @@
  *
  *  REQUEST_ENTITY_LIST: //request the whole world :D
- *  REQUEST_SYNC:        >> UNIQUE_ID
- *                       << [Sync Info]
- *  //REQUEST_SYNC_LIST:   NUMBER, [UNIQUE_ID][0..NUMBER]
- *
  *  YOU_ARE_ENTITY:      >> UNIQUE_ID
  *
@@ -54,5 +50,4 @@
   NET_REQUEST_CREATE,
   NET_REQUEST_REMOVE,
-  NET_REQUEST_SYNC,
   NET_YOU_ARE_ENTITY,
   NET_REQUEST_ENTITY_LIST,
@@ -91,6 +86,4 @@
     void sendYouAre( int uniqueID, int userID );
 
-    void sync(int uniqueID, int owner);
-
     void sendEntityList(int userID);
 
@@ -111,5 +104,4 @@
     bool handleRemoveEntityList( int& i, const byte* data, int length, int sender );
     bool handleYouAreEntity( int& i, const byte* data, int length, int sender );
-    bool handleRequestSync( int& i, const byte* data, int length, int sender );
     bool handleRequestPNodePath(int& i, const byte* data, int length, int sender);
     bool handleSendPNodePath(int& i, const byte* data, int length, int sender);
@@ -124,7 +116,4 @@
     void executeRemoveEntity(int uniqueID);
     void doRemoveEntity(int uniqueID);
-
-    void executeRequestSync( int uniqueID, int user );
-    void doRequestSync(int uniqueID, int userID);
 
     void doYouAre( int uniqueID );
Index: /branches/network/src/lib/network/network_stream.cc
===================================================================
--- /branches/network/src/lib/network/network_stream.cc	(revision 7443)
+++ /branches/network/src/lib/network/network_stream.cc	(revision 7444)
@@ -250,5 +250,8 @@
 
         reciever = 0;
-        dataLength = (*it)->readBytes(downBuffer, DATA_STREAM_BUFFER_SIZE, &reciever);
+#warning fix this
+dataLength = 0;
+//TODO fix
+        //dataLength = (*it)->readBytes(downBuffer, DATA_STREAM_BUFFER_SIZE, &reciever);
 
         if ( dataLength<=0 ){
@@ -345,4 +348,6 @@
         for (SynchronizeableList::iterator it = synchronizeables.begin(); it!=synchronizeables.end(); it++)
         {
+#warning fix this
+#if 0
           if ( *it && (*it)->getUniqueID()==header.synchronizeableID )
           {
@@ -354,4 +359,5 @@
             continue;
           }
+#endif
         }
 
@@ -388,5 +394,5 @@
     if ( clientId > this->maxConnections )
     {
-      handshakes[clientId]->doReject();
+      handshakes[clientId]->doReject( "too many connections" );
       PRINTF(0)("Will reject client %d because there are to many connections!\n", clientId);
     }
Index: /branches/network/src/lib/network/synchronizeable.cc
===================================================================
--- /branches/network/src/lib/network/synchronizeable.cc	(revision 7443)
+++ /branches/network/src/lib/network/synchronizeable.cc	(revision 7444)
@@ -36,11 +36,8 @@
   this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
   this->owner = -1;
-  this->state = 0;
   this->hostID = SharedNetworkData::getInstance()->getHostID();
   this->setIsServer(this->hostID == 0);
   this->uniqueID = NET_UID_UNASSIGNED;
   this->networkStream = NULL;
-  this->setRequestedSync( false );
-  this->setIsOutOfSync( !(this->isServer()) );
   this->bSynchronize = false;
 
@@ -52,4 +49,6 @@
     this->setUniqueID(SharedNetworkData::getInstance()->getNewUniqueID());
   }
+  
+  this->registerVar( new SynchronizeableString( &this->objectName, &this->objectName, "objectName" ) );
 }
 
@@ -64,31 +63,4 @@
     this->networkStream->disconnectSynchronizeable(*this);
 }
-
-
-/**
- *  write data to NetworkStream
- */
-int Synchronizeable::writeBytes(const byte* data, int length, int sender)
-{
-  PRINTF(5)("Synchronizeable::writeBytes was called\n");
-}
-
-
-/**
- *  read data from NetworkStream
- */
-int Synchronizeable::readBytes(byte* data, int maxLength, int * reciever)
-{
-  PRINTF(5)("Synchronizeable::readBytes was called\n");
-}
-
-
-void Synchronizeable::writeDebug() const
-{}
-
-
-void Synchronizeable::readDebug() const
-{}
-
 
 /**
@@ -106,18 +78,4 @@
 
 /**
- * Sets the outofsync flag to a given value
- * @param outOfSync: the boolean value which the outofsync flag is to set to
- */
-void Synchronizeable::setIsOutOfSync(bool outOfSync)
-{
-  if( outOfSync )
-    this->state = this->state | STATE_OUTOFSYNC;
-  else
-    this->state = this->state & (~STATE_OUTOFSYNC);
-  //PRINTF(0)("isoutofsync %s %d\n", this->getClassName(), state);
-}
-
-
-/**
  * Determines if the server flag is set
  * @return true, if the server flag is true, false else
@@ -130,35 +88,59 @@
 
 /**
- * Determines if the outofsync flag is set
- * @return true, if the outofsync flag is true, false else
+ * get the diff to last acked state of userId
+ * @param userId user to create diff for
+ * @param data buffer to copy diff in
+ * @param maxLength max bytes to copy into data
+ * @param stateId id of current state
+ * @param priorityTH tells getStateDiff to not send element with priority \< priorityTH
+ * @return n bytes copied into data
  */
-bool Synchronizeable::isOutOfSync()
+int Synchronizeable::getStateDiff( int userId, byte* data, int maxLength, int stateId, int priorityTH )
 {
-  return (this->state & STATE_OUTOFSYNC) >0;
+#warning implement this
+}
+
+/**
+ * sets a new state out of a diff created on another host
+ * @param userId hostId of user who send me that diff
+ * @param data pointer to diff
+ * @param length length of diff
+ * @param stateId id of current state
+ * @return true on success
+ */
+bool Synchronizeable::setStateDiff( int userId, byte* data, int length, int stateId )
+{
+#warning implement this
+}
+
+ /**
+ * override this function to be notified on change
+ * of your registred variables.
+ * @param id id's which have changed
+ */
+void varChangeHandler( std::list<int> & id )
+{
+#warning implement this
+}
+
+/**
+ * registers a varable to be synchronized over network
+ * @param var see src/lib/network/synchronizeable_var/ for available classes
+ */
+void Synchronizeable::registerVar( SynchronizeableVar * var )
+{
+#warning implement this
+}
+
+/**
+ * registers a varable to be synchronized over network
+ * return value is passed to varChangeHandler on change
+ * @param var see src/lib/network/synchronizeable_var/ for available classes
+ * @return handle passed to varChangeHandler on changes
+ */
+int Synchronizeable::registerVarId( SynchronizeableVar * var )
+{
+#warning implement this
 }
 
 
-/**
- * Determines if the requestedSync flag is set
- * @return true, if the requestedSync flag is true, false else
- */
-bool Synchronizeable::requestedSync()
-{
-  return (this->state & STATE_REQUESTEDSYNC) >0;
-}
-
-
-/**
- * Sets the requestedsync flag to a given value
- * @param requestedSync: the boolean value which the requestedsync flag is to set to
- */
-void Synchronizeable::setRequestedSync( bool requestedSync )
-{
-  if( requestedSync )
-    this->state = this->state | STATE_REQUESTEDSYNC;
-  else
-    this->state = this->state & (~STATE_REQUESTEDSYNC);
-}
-
-
-
